import numpy as np
from DateTime import DateTime

progress_indicator = in_stream["Progress Indicator"]
in_data_stream = in_stream["Data Stream"]
start = progress_indicator.getIntOffsetIndex()
end = in_data_stream.getSize()
if start >= end:
  return

e_rab_data_array = None
e_utran_data_array = None

for array in out_array:
  if array['variation'] == 'e_rab':
    e_rab_data_array = array['Data Array']
  if array['variation'] == 'e_utran':
    e_utran_data_array = array['Data Array']

data = in_data_stream.getData().decode('utf8')
vt, vInititialEPSBEstabSR, vAddedEPSBEstabSR, evt, vIPThp_qci = context.Base_getORSKPIValue(data)

e_rab_dtype = np.dtype([
  ('vt', 'float'),
  ('vInititialEPSBEstabSR_lo', 'float64'),
  ('vInititialEPSBEstabSR_hi', 'float64'),
  ('vAddedEPSBEstabSR_lo', 'float64'),
  ('vAddedEPSBEstabSR_hi', 'float64'),
])

e_utran_dtype =np.dtype([
  ('evt', 'float'),
  ('dl_lo', 'float64'),
  ('dl_hi', 'float64'),
  ('ul_lo', 'float64'),
  ('ul_hi', 'float64'),
])

e_rab_array = e_rab_data_array.getArray()
#XXXXXXXXXX initialise every time because of kpi calculation
if not e_rab_array or True:
  e_rab_array = e_rab_data_array.initArray(shape=(0,), dtype=e_rab_dtype)
e_rab_array_data = []


e_utran_array = e_utran_data_array.getArray()
#XXXXXXXXXX initialise every time because of kpi calculation
if not e_utran_array or True:
  e_utran_array = e_utran_data_array.initArray(shape=(0,), dtype=e_utran_dtype )
e_utran_array_data = []

for i in range(len(vt)):
  e_rab_array_data.append((vt[i], vInititialEPSBEstabSR[i][0], vInititialEPSBEstabSR[i][1], vAddedEPSBEstabSR[i][0], vAddedEPSBEstabSR[i][1]))

for i in range(len(evt)):
  for j in vIPThp_qci[i]:
    e_utran_array_data.append((evt[i], j[0], j[1], j[2], j[3]))

if e_rab_array_data:
  e_rab_array_data =  np.ndarray((len(e_rab_array_data), ), e_rab_dtype, np.array(e_rab_array_data))
  e_rab_array.append(e_rab_array_data)
if e_utran_array_data:
  e_utran_array_data =  np.ndarray((len(e_utran_array_data), ), e_utran_dtype, np.array(e_utran_array_data))
  e_utran_array.append(e_utran_array_data)


progress_indicator.setIntOffsetIndex(end)

return
